Accounts are linked using the industry standard OAuth 2.0 *authorization
code* flow.

## OAuth 2.1 \& PKCE for Agents

For stateless AI agents and multi-modal pipelines, **OAuth 2.1** enforcement is
recommended.

- **PKCE (Proof Key for Code Exchange)**: Must be used to secure the authorization code flow, preventing interception attacks.
- **No Implicit Flow**: The implicit flow exposes access tokens in the URL, which is a security risk for agent environments.

Your service must support OAuth 2.0/2.1 compliant *authorization* and *token
exchange* endpoints.

> [!NOTE]
> **Note:** The implicit flow is deprecated and no longer supported for new integrations. If you are maintaining an existing implicit flow integration, see the [Archived Implicit Flow](https://developers.google.com/identity/account-linking/archive/implicit-flow) documentation.

## Create the project

> [!NOTE]
> **Note:** You can reuse an existing project and do not need to create a new project primarily for account linking.

To create your project to use account linking:

1. Go to the [Google API Console](https://console.developers.google.com/project).
2. Click **Create project**.
3. Enter a name or accept the generated suggestion.
4. Confirm or edit any remaining fields.
5. Click **Create**.

To view your project ID:

1. Go to the [Google API Console](https://console.developers.google.com/project).
2. Find your project in the table on the landing page. The project ID appears in the **ID** column.

## Configure your OAuth Consent Screen

The Google Account Linking process includes a consent screen which tells users the application requesting access to their data, what kind of data they are asking for and the terms that apply. You will need to configure your OAuth consent screen before generating a Google API client ID.

1. Open the [OAuth consent screen](https://console.developers.google.com/apis/credentials/consent) page of the Google APIs console.
2. If prompted, select the project you just created.
3. On the "OAuth consent screen" page, fill out the form and click the "Save" button.

   **Application name:** The name of the application asking for consent. The name should accurately reflect your application and be consistent with the application name users see elsewhere. The application name will be shown on the Account Linking consent screen.

   **Application logo:** An image on the consent screen that will help users recognize your app. The logo is shown on Account linking consent screen and on [account settings](https://myaccount.google.com/permissions)

   **Support email:** For users to contact you with questions about their consent.

   **Scopes for Google APIs:** Scopes allow your application to access your user's private Google data. For the Google Account Linking use case, default scope (email, profile, openid) is sufficient, you don't need to add any sensitive scopes. It is generally a best practice to request scopes incrementally, at the time access is required, rather than up front. [Learn more](https://developers.google.com/identity/protocols/oauth2/scopes).

   **Authorized domains:** To protect you and your users, Google only allows applications that authenticate using OAuth to use Authorized Domains. Your applications' links must be hosted on Authorized Domains. [Learn more](https://support.google.com/cloud/answer/6158849#authorized-domains).

   **Application Homepage link:** Home page for your application. Must be hosted on an Authorized Domain.

   **Application Privacy Policy link:** Shown on Google Account Linking consent screen. Must be hosted on an Authorized Domain.

   **Application Terms of Service link (Optional):** Must be hosted on an Authorized Domain.
   ![](https://developers.google.com/static/identity/account-linking/images/gal-consent-screen.png)

   **Figure 1**. Google Account Linking Consent Screen for a fictitious Application, Tunery
4. Check "Verification Status", if your application needs verification then click the "Submit For Verification" button to submit your application for verification. Refer to [OAuth verification requirements](https://support.google.com/cloud/answer/9110914) for details.

## Implement your OAuth server

An OAuth 2.0 server implementation of the *authorization code* flow consists of
two endpoints, which your service makes available by HTTPS. The first endpoint
is the authorization endpoint, which is responsible for finding or obtaining
consent from users for data access. The authorization endpoint presents a
sign-in UI to your users that aren't already signed in and records consent to
the requested access. The second endpoint is the token exchange endpoint, which
is used to obtain encrypted strings, called tokens, that authorize a user to
access your service.

When a Google application needs to call one of your service's APIs, Google uses
these endpoints together to get permission from your users to call these APIs
on their behalf.

### Google Account Linking: OAuth Authorization Code Flow

The following sequence diagram details interactions between the User, Google,
and your service's endpoints.
User Google App / Browser Google Server Your Auth Endpoint Your Token Endpoint 1. User initiates linking 2. Redirect to Auth Endpoint (GET) client_id, redirect_uri, state, scope 3. Display Sign-in \& Consent Screen 4. User Authenticates \& Grants Consent 5. Redirect back to Google (GET) code, state 6. Handle redirect \& pass code/state 7. Token Exchange (POST) grant_type=authorization_code, code 8. Return Tokens (200 OK) access_token, refresh_token 9. Store user tokens 10. Access user resources **Figure 1.** The sequence of events in the OAuth 2.0 Authorization Code flow for Google Account Linking.

### Roles and responsibilities

The following table defines the roles and responsibilities of the actors in the
Google Account Linking (GAL) OAuth flow. Note that in GAL, Google acts as the
OAuth **Client** , while your service acts as the
**Identity/Service Provider**.

| Actor / Component | GAL Role | Responsibilities |
|---|---|---|
| **Google App / Server** | OAuth Client | Initiates the flow, receives the authorization code, exchanges it for tokens, and securely stores them to access your service's APIs. |
| **Your Authorization Endpoint** | Authorization Server | Authenticates your users and obtains their consent to share access to their data with Google. |
| **Your Token Exchange Endpoint** | Authorization Server | Validates authorization codes and refresh tokens, and issues access tokens to the Google Server. |
| **Google Redirect URI** | Callback Endpoint | Receives the user redirect from your authorization service with the `code` and `state` values. |

An OAuth 2.0 authorization code flow session initiated by Google has the
following flow:

1. Google opens your authorization endpoint in the user's browser. If the flow started on a voice-only device for an Action, Google transfers the execution to a phone.
2. The user signs in, if not signed in already, and grants Google permission to access their data with your API, if they haven't already granted permission.
3. Your service creates an *authorization code* and returns it to Google. To do so, redirect the user's browser back to Google with the authorization code attached to the request.
4. Google sends the authorization code to your token exchange endpoint, which verifies the authenticity of the code and returns an *access token* and a *refresh token*. The access token is a short-lived token that your service accepts as credentials to access APIs. The refresh token is a long-lived token that Google can store and use to acquire new access tokens when they expire.
5. After the user has completed the account linking flow, every subsequent request sent from Google contains an access token.

## Implementation Recipe

Follow these steps to implement the Authorization Code flow.

### Step 1: Handle authorization requests

When Google initiates account linking, it redirects the user to your
authorization endpoint. For detailed protocol contracts and parameter
requirements, see the [Authorization Endpoint](https://developers.google.com/identity/account-linking/your-api-reference#authorization-endpoint).

To handle the request, perform the following actions:

1. **Validate the request**:

   - Confirm that the `client_id` matches the Client ID assigned to Google.
   - Confirm that the `redirect_uri` matches the expected Google redirect URL:
     - **Prod:** `https://oauth-redirect.googleusercontent.com/r/YOUR_PARTNER_ID`
     - **Sandbox:** `https://oauth-redirect-sandbox.googleusercontent.com/r/YOUR_PARTNER_ID`
   - Verify that `response_type` is `code`.
2. **Authenticate the user**:

   - Check if the user is signed in to your service.
   - If the user is not signed in, prompt them to complete your sign-in or sign-up flow.
3. **Generate authorization code**:

   - Create a unique, non-guessable authorization code associated with the user and client.
   - Set the code to expire in approximately 10 minutes.
4. **Redirect back to Google**:

   - Redirect the browser to the URL provided in `redirect_uri`.
   - Append the following query parameters:
     - `code`: The authorization code you generated.
     - `state`: The unmodified state value received from Google.

### Step 2: Handle token exchange requests

Your token exchange endpoint processes two types of requests: exchanging codes
for tokens, and refreshing expired access tokens. For detailed protocol
contracts and parameter requirements, see the [Token Exchange
Endpoint](https://developers.google.com/identity/account-linking/your-api-reference#token-exchange-endpoint).

#### A. Exchange authorization codes for tokens

When Google receives the authorization code, it calls your token exchange
endpoint (POST) to retrieve tokens.

1. **Validate the request**:

   - Verify `client_id` and `client_secret`.
   - Verify the authorization code is valid and not expired.
   - Confirm `redirect_uri` matches the value used in Step 1.
   - If validation fails, return an HTTP `400 Bad Request` with `{"error": "invalid_grant"}`.
2. **Issue tokens**:

   - Generate a long-lived `refresh_token` and a short-lived `access_token` (typically 1 hour).
   - Return an HTTP `200 OK` with the standard JSON token response.

#### B. Refresh access tokens

When the access token expires, Google requests a new one using the refresh
token.

1. **Validate the request**:

   - Verify `client_id`, `client_secret`, and `refresh_token`.
   - If validation fails, return an HTTP `400 Bad Request` with `{"error": "invalid_grant"}`.
2. **Issue new access token**:

   - Generate a new short-lived `access_token`.
   - Return an HTTP `200 OK` with the JSON token response (optionally including a new refresh token).

##### Handle userinfo requests

The [userinfo endpoint](https://openid.net/specs/openid-connect-core-1_0.html#userinfo) is an OAuth 2.0 protected resource that return claims about the linked user. Implementing and hosting the userinfo endpoint is optional, except for the following use cases:

- [Linked Account Sign-In](https://developers.google.com/identity/one-tap/android/linked-account-signin) with Google One Tap.
- [Frictionless subscription](https://www.youtube.com/watch?v=ARuf97ncE4w) on AndroidTV.

After the access token has been successfully retrieved from your token endpoint, Google sends a request to your userinfo endpoint to retrieve basic profile information about the linked user.

| userinfo endpoint request headers ||
|---|---|
| `Authorization header` | The access token of type Bearer. |

For example, if your userinfo endpoint is available at
`https://myservice.example.com/userinfo`, a request might look like the following:

```
GET /userinfo HTTP/1.1
Host: myservice.example.com
Authorization: Bearer ACCESS_TOKEN
```

For your userinfo endpoint to handle requests, do the following steps:

1. Extract access token from the Authorization header and return information for the user associated with the access token.
2. If the access token is invalid, return an HTTP 401 Unauthorized error with using the `WWW-Authenticate` Response Header. Below is an example of a userinfo error response:

   ```
   HTTP/1.1 401 Unauthorized
   WWW-Authenticate: error="invalid_token",
   error_description="The Access Token expired"
   ```
   If a 401 Unauthorized, or any other unsuccessful error response is returned during the linking process, the error will be non-recoverable, the retrieved token will be discarded and the user will have to initiate the linking process again.
3. If the access token is valid, return and HTTP 200 response with the following JSON object in the body of the HTTPS
   response:

   ```
   {
   "sub": "USER_UUID",
   "email": "EMAIL_ADDRESS",
   "given_name": "FIRST_NAME",
   "family_name": "LAST_NAME",
   "name": "FULL_NAME",
   "picture": "PROFILE_PICTURE",
   }
   ```
   If your userinfo endpoint returns an HTTP 200 success response, the retrieved token and claims are registered against the user's Google account.

   <br />

   | userinfo endpoint response ||
   |---|---|
   | `sub` | A unique ID that identifies the user in your system. |
   | `email` | Email address of the user. |
   | `given_name` | **Optional:** First name of the user. |
   | `family_name` | **Optional:** Last name of the user. |
   | `name` | **Optional:** Full name of the user. |
   | `picture` | **Optional:** Profile picture of the user. |

## Validating your implementation

You can validate your implementation by using the
[OAuth 2.0 Playground](https://developers.google.com/oauthplayground/) tool.

In the tool, do the following steps:

1. Click **Configuration** to open the OAuth 2.0 Configuration window.
2. In the **OAuth flow** field, select **Client-side**.
3. In the **OAuth Endpoints** field, select **Custom**.
4. Specify your OAuth 2.0 endpoint and the client ID you assigned to Google in the corresponding fields.
5. In the **Step 1** section, don't select any Google scopes. Instead, leave this field blank or type a scope valid for your server (or an arbitrary string if you don't use OAuth scopes). When you're done, click **Authorize
   APIs**.
6. In the **Step 2** and **Step 3** sections, go through the OAuth 2.0 flow and verify that each step works as intended.

You can validate your implementation by using the
[Google Account Linking Demo](https://gal-demo.withgoogle.com) tool.

In the tool, do the following steps:

1. Click the **Sign in with Google** button.
2. Choose the account you'd like to link.
3. Enter the service ID.
4. Optionally enter one or more scopes that you will request access for.
5. Click **Start Demo**.
6. When prompted, confirm that you may consent and deny the linking request.
7. Confirm that you are redirected to your platform.